## libgmpada 1.1

=== Makefile ===
#    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
#    Copyright (C) 2007-2017 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

########################
# Global configuration #
########################

LIB_NAME := gmpada

SOVERSION := 2

################################
# Build and test configuration #
################################

# Use environment variables if available, this is common practice for
# CFLAGS and LDFLAGS.
CPPFLAGS ?=
CFLAGS   ?= -O2
ADAFLAGS ?= -O2 -gnatn
# Inlining helps a lot for the thin binding.
LDFLAGS  ?=

.NOTPARALLEL:
GNATMAKE_OPTIONS := -j$(shell getconf _NPROCESSORS_ONLN)

ifdef ALL_CHECKS
  CFLAGS += -Wall -Wextra -pedantic -Wformat-security -g
  ADAFLAGS += -Wall -Wextra -g -gnataEfoqQ -gnatVa -gnatw.eH.Y \
  -gnatyBdIoOSuxy -fstack-check
  LDFLAGS += -Wl,--as-needed -Wl,-z,defs
  GNATMAKE_OPTIONS := -s -v
endif

# We want the same compiler for C and Ada sources.
# Accept both gcc-4.9 and gcc-5.
CC := $(notdir $(shell which `gnatmake --version \
  | sed '1{s/^GNATMAKE \(\([0-9]\+\)\.[0-9]\+\).*/gcc-\1 gcc-\2/;q}'`))
ifneq ($(words $(CC)),1)
 $(error Failed to set CC from gnatmake output.)
endif

LDLIBS := -lgmp

##############################
# Installation configuration #
##############################

# Each of the following path should be prefixed with
DESTDIR :=

# The sources files are installed into a LIB_NAME subdirectory of
SRC_DIR := usr/share/ada/adainclude

# A LIB_NAME.gpr project convenient for library usage is installed into
GPR_DIR := usr/share/gpr
# The content of this file ignores DESTDIR.

# The GNAT ALI files are installed into a LIB_NAME subdirectory of
ALI_DIR := usr/lib/ada/adalib

# The static and dynamic library are installed into
LIB_DIR := usr/lib

#########
# Rules #
#########

ada_bodies      := $(wildcard src/*.adb)
ada_specs       := src/gmp-constants.ads \
  $(filter-out src/gmp-constants.ads,$(wildcard src/*.ads))
ada_units       := $(ada_bodies) $(filter-out $(ada_bodies:b=s),$(ada_specs))
C_SOURCES       := $(wildcard src/*.c)
C_OBJ_DYNAMIC   := $(patsubst src/%.c,obj-dynamic/%.o,$(C_SOURCES))
C_OBJ_STATIC    := $(patsubst src/%.c,obj-static/%.o, $(C_SOURCES))

# Default target is:
.PHONY: build
build: obj/lib$(LIB_NAME).so.$(SOVERSION) \
       obj/lib$(LIB_NAME).a \
       obj/$(LIB_NAME).gpr

obj/lib$(LIB_NAME).so.$(SOVERSION): $(ada_bodies) $(ada_specs) $(C_OBJ_DYNAMIC) | obj
	gnatmake -c $(ada_units) -D obj-dynamic $(GNATMAKE_OPTIONS) \
          -cargs $(ADAFLAGS) -fPIC
	$(CC) -shared -o $@ -Wl,-soname,lib$(LIB_NAME).so.$(SOVERSION) \
          obj-dynamic/*.o $(LDFLAGS) $(LDLIBS) -lgnat

obj/lib$(LIB_NAME).a: $(ada_bodies) $(ada_specs) $(C_OBJ_STATIC) | obj
	gnatmake -c $(ada_units) -D obj-static $(GNATMAKE_OPTIONS) \
          -cargs $(ADAFLAGS)
	ar cr $@ obj-static/*.o
	ranlib $@

$(C_OBJ_DYNAMIC): obj-dynamic/%.o: src/%.c | obj-dynamic
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@ -fPIC

$(C_OBJ_STATIC): obj-static/%.o: src/%.c | obj-static
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@

obj/$(LIB_NAME).gpr: template_for_installed_project
	sed \
          -e s/@LIB_NAME@/$(LIB_NAME)/ \
          -e '/@LDLIBS@/{s||$(patsubst %,"%",$(LDLIBS))|;s/" "/", "/g}' \
          $(foreach d,SRC ALI LIB \
          ,-e "s|@$(d)_DIR@|`realpath -m $($(d)_DIR) --relative-to=$(GPR_DIR)`|") \
          $< > $@

src/gmp-constants.ads: obj/generate_constants | obj
	$< > $@
obj/generate_constants: generate_constants.c | obj
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $< $(LDLIBS) -o $@

obj obj-dynamic obj-static:
	mkdir $@
clean::
	rm -f src/gmp-constants.ads
	rm -fr obj obj-dynamic obj-static
	find -name "*~" -delete

######################################################################
.PHONY: test
test: | demo-dynamic demo-static
	$(MAKE) install DESTDIR=demo-install

	gnatmake demo.adb -o demo-dynamic/demo -D demo-dynamic $(GNATMAKE_OPTIONS) \
          -aIdemo-install/$(SRC_DIR)/$(LIB_NAME) \
          -aOdemo-install/$(ALI_DIR)/$(LIB_NAME) \
          -cargs $(ADAFLAGS) \
          -largs $(LDFLAGS) -Ldemo-install/$(LIB_DIR) -l$(LIB_NAME) $(LDLIBS)
	LD_LIBRARY_PATH=demo-install/$(LIB_DIR) demo-dynamic/demo

	gnatmake demo.adb -o demo-static/demo -D demo-static $(GNATMAKE_OPTIONS) \
          -aIdemo-install/$(SRC_DIR)/$(LIB_NAME) \
          -aOdemo-install/$(ALI_DIR)/$(LIB_NAME) \
          -cargs $(ADAFLAGS) \
          -largs $(LDFLAGS) demo-install/$(LIB_DIR)/lib$(LIB_NAME).a $(LDLIBS)
	demo-static/demo

	$(MAKE) uninstall DESTDIR=demo-install
	test `find demo-install -type f | wc -l` = 0

demo-dynamic demo-static:
	mkdir $@
clean::
	rm -fr demo-dynamic demo-install demo-static

######################################################################
.PHONY: install
install: build
	install --directory $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	install --mode=644 $(ada_bodies) $(ada_specs) $(C_SOURCES) $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	install --directory $(DESTDIR)/$(GPR_DIR)
	install --mode=644 obj/$(LIB_NAME).gpr $(DESTDIR)/$(GPR_DIR)
	install --directory $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	install --mode=444 obj-dynamic/*.ali $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	install --directory $(DESTDIR)/$(LIB_DIR)
	install --mode=644 obj/lib$(LIB_NAME).a $(DESTDIR)/$(LIB_DIR)
	install --mode=644 obj/lib$(LIB_NAME).so.$(SOVERSION) $(DESTDIR)/$(LIB_DIR)
	ln --force --symbolic lib$(LIB_NAME).so.$(SOVERSION) $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so

.PHONY: uninstall
uninstall:
	rm -rf $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	rm -f $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
	rm -rf $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).a
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so.$(SOVERSION)
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so

######################################################################
.PHONY: clean

=== debian/changelog ===
libgmpada (1.1-3) unstable; urgency=medium

  * Debhelper 11.
  * Drop obsolete version restriction on dpkg-dev.
  * Standards-Version 4.1.4.
  * Update URI syntax of VCS-Mtn field.
  * Disable tests if DEB_BUILD_OPTIONS contains nocheck.
  * Increase verbosity of run time test.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 03 May 2018 17:59:51 +0200

libgmpada (1.1-2) unstable; urgency=medium

  * Upload to unstable. Change versions: SO (runtime) and ALI (-dev).
  * Standards-Version: 4.0.1. Priority: optional.
  * Drop explicit rules targets confusing dh.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 09 Aug 2017 19:54:28 +0200

libgmpada (1.1-1) experimental; urgency=medium

  * New upstream built with gnat-7. No ALI/SO change in experimental.
    Drop dependency on mpfr and kfreebsd-amd64-gnat6-bug-in-test.diff.
  * Drop -pie from explicit hardening flags.
  * Standards-Version: 4.0.0. HTTPS version of copyright-format URL.
  * Debhelper 10.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 06 Jul 2017 12:56:40 +0200

=== debian/control ===
Source: libgmpada
Section: libdevel
Priority: optional
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: debhelper (>= 11),
 gnat, gnat-7,
# This line is parsed by debian/rules.
 dh-ada-library (>= 6.7),
# dh-ada-library >= 6.7 stops requiring -dbg packages.
 libgmp-dev
Standards-Version: 4.1.4
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
Vcs-Mtn: mtn://www.ada-france.org?org.debian.libgmpada
Homepage: http://nicolas.boulenguez.free.fr

Package: libgmpada7-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends},
 libgmp-dev
Description: Ada binding to the GNU MultiPrecision library: development
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats.
 .
 Install this package if you want to write programs that
 use libgmpada.

Package: libgmpada5
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ada binding to the GNU MultiPrecision library: shared library
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats.
 .
 This package contains the runtime shared library.

=== debian/rules ===
#!/usr/bin/make -f

$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/ \
    GNAT_VERSION:=\1 \
  /p;\
  s/^Package: lib[a-z-]\+\([0-9.]\+\)$$/ \
    SOVERSION:=\1 \
  /p;\
  ' debian/control),$(eval $(line)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk

%:
	dh $@ --with ada-library

.PHONY: override_dh_auto_build
override_dh_auto_build:
  # -gnatn is very useful for the thin binding.
	dh_auto_build -- \
	  $(foreach v,CFLAGS CPPFLAGS LDFLAGS SOVERSION,$(v)='$($(v))') \
	  ADAFLAGS='$(ADAFLAGS) -gnatn' \
	  GNATMAKE_OPTIONS='$(BUILDER_OPTIONS)'

.PHONY: override_dh_auto_test
override_dh_auto_test:
  ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test -- \
	  $(foreach v,CFLAGS CPPFLAGS LDFLAGS SOVERSION,$(v)='$($(v))') \
	  ADAFLAGS='$(ADAFLAGS) -gnata' \
	  GNATMAKE_OPTIONS='$(BUILDER_OPTIONS)'
  endif

# Ignore this target from upstream Makefile.
.PHONY: override_dh_auto_install

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --all $(addprefix --exclude=,.ads .adb Makefile .c .h)

## libgmpada 1.2

=== Makefile ===
--- 
+++ 
@@ -52,6 +52,7 @@
 ifneq ($(words $(CC)),1)
  $(error Failed to set CC from gnatmake output.)
 endif
+CXX := $(subst cc,++,$(CC))
 
 LDLIBS := -lgmp
 
@@ -80,8 +81,8 @@
 #########
 
 ada_bodies      := $(wildcard src/*.adb)
-ada_specs       := src/gmp-constants.ads \
-  $(filter-out src/gmp-constants.ads,$(wildcard src/*.ads))
+ada_specs       := src/gmp-h.ads \
+  $(filter-out src/gmp-h.ads,$(wildcard src/*.ads))
 ada_units       := $(ada_bodies) $(filter-out $(ada_bodies:b=s),$(ada_specs))
 C_SOURCES       := $(wildcard src/*.c)
 C_OBJ_DYNAMIC   := $(patsubst src/%.c,obj-dynamic/%.o,$(C_SOURCES))
@@ -119,15 +120,15 @@
           ,-e "s|@$(d)_DIR@|`realpath -m $($(d)_DIR) --relative-to=$(GPR_DIR)`|") \
           $< > $@
 
-src/gmp-constants.ads: obj/generate_constants | obj
-	$< > $@
-obj/generate_constants: generate_constants.c | obj
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $< $(LDLIBS) -o $@
+src/gmp-h.ads: gmp-h.ads.sed | obj
+	echo '#include <gmp.h>' > obj/tmp.h
+	cd obj && $(CXX) --dump-ada-spec tmp.h
+	sed -f $< obj/*_gmp_h.ads > $@
 
 obj obj-dynamic obj-static:
 	mkdir $@
 clean::
-	rm -f src/gmp-constants.ads
+	rm -f src/gmp-h.ads
 	rm -fr obj obj-dynamic obj-static
 	find -name "*~" -delete

=== debian/changelog ===
libgmpada (1.2-2) unstable; urgency=medium

  * Rebuild in unstable for gnat-8 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 27 Oct 2018 15:09:55 +0200

libgmpada (1.2-1) experimental; urgency=medium

  * New upstream release. Rebuild with gnat-8, gcc-8.
    Rename shared library and -dev package per Debian Ada policy.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 08 May 2018 14:01:35 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,10 @@
 Priority: optional
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends: debhelper (>= 11),
- gnat, gnat-7,
+ gnat, gnat-8,
 # This line is parsed by debian/rules.
+ g++-8,
+# The same version is required to generate the thin binding.
  dh-ada-library (>= 6.7),
 # dh-ada-library >= 6.7 stops requiring -dbg packages.
  libgmp-dev
@@ -13,7 +15,7 @@
 Vcs-Mtn: mtn://www.ada-france.org?org.debian.libgmpada
 Homepage: http://nicolas.boulenguez.free.fr
 
-Package: libgmpada7-dev
+Package: libgmpada8-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends},
  libgmp-dev
@@ -25,7 +27,7 @@
  Install this package if you want to write programs that
  use libgmpada.
 
-Package: libgmpada5
+Package: libgmpada6
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -26,12 +26,12 @@
 
 .PHONY: override_dh_auto_test
 override_dh_auto_test:
-  ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	dh_auto_test -- \
 	  $(foreach v,CFLAGS CPPFLAGS LDFLAGS SOVERSION,$(v)='$($(v))') \
 	  ADAFLAGS='$(ADAFLAGS) -gnata' \
 	  GNATMAKE_OPTIONS='$(BUILDER_OPTIONS)'
-  endif
+endif
 
 # Ignore this target from upstream Makefile.
 .PHONY: override_dh_auto_install

## libgmpada 1.3

=== Makefile ===
--- 
+++ 
@@ -30,6 +30,7 @@
 # CFLAGS and LDFLAGS.
 CPPFLAGS ?=
 CFLAGS   ?= -O2
+CXXFLAGS ?=
 ADAFLAGS ?= -O2 -gnatn
 # Inlining helps a lot for the thin binding.
 LDFLAGS  ?=
@@ -122,7 +123,7 @@
 
 src/gmp-h.ads: gmp-h.ads.sed | obj
 	echo '#include <gmp.h>' > obj/tmp.h
-	cd obj && $(CXX) --dump-ada-spec tmp.h
+	cd obj && $(CXX) $(CPPFLAGS) $(CXXFLAGS) --dump-ada-spec tmp.h
 	sed -f $< obj/*_gmp_h.ads > $@
 
 obj obj-dynamic obj-static:

=== debian/changelog ===
libgmpada (1.3-2) unstable; urgency=medium

  * Reupload to unstable for gnat-9 transition. Closes: #944185.
  * Debhelper 12: dh-sequence syntax, examples are not compressed.
  * Standards-Version 4.5.0.
  * Drop redundant branch in Vcs-Git.
  * Drop explicit --as-needed, enabled by default by gcc-9.
  * Select specific dpkg-dev Makefile snippet.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 25 Feb 2020 11:53:20 +0100

libgmpada (1.3-1) experimental; urgency=medium

  * New upstream release, built with gnat-9.
    Migration in experimental, renaming lib and -dev packages.
  * Move Version Control System to salsa.
  * Standards-Version 4.4.0.
  * Rules-Requires-Root no.
  * Debhelper 12.
  * Remove unused signatures from upstream/signing-key.asc.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 18 Jul 2019 14:07:22 +0200

=== debian/control ===
--- 
+++ 
@@ -2,20 +2,21 @@
 Section: libdevel
 Priority: optional
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
-Build-Depends: debhelper (>= 11),
- gnat, gnat-8,
+Build-Depends:
+ debhelper-compat (= 12),
+ dh-sequence-ada-library,
+ gnat, gnat-9,
 # This line is parsed by debian/rules.
- g++-8,
+ g++-9,
 # The same version is required to generate the thin binding.
- dh-ada-library (>= 6.7),
-# dh-ada-library >= 6.7 stops requiring -dbg packages.
- libgmp-dev
-Standards-Version: 4.1.4
-Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
-Vcs-Mtn: mtn://www.ada-france.org?org.debian.libgmpada
+ libgmp-dev,
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/debian/libgmpada
+Vcs-Git: https://salsa.debian.org/debian/libgmpada.git
 Homepage: http://nicolas.boulenguez.free.fr
 
-Package: libgmpada8-dev
+Package: libgmpada9-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends},
  libgmp-dev
@@ -27,7 +28,7 @@
  Install this package if you want to write programs that
  use libgmpada.
 
-Package: libgmpada6
+Package: libgmpada7
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -10,11 +10,13 @@
   ' debian/control),$(eval $(line)))
 
 DEB_BUILD_MAINT_OPTIONS := hardening=+all
-include /usr/share/dpkg/default.mk
+DEB_LDFLAGS_MAINT_APPEND := -Wl,--no-undefined \
+  -Wl,--no-copy-dt-needed-entries -Wl,--no-allow-shlib-undefined
+include /usr/share/dpkg/buildflags.mk
 include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk
 
 %:
-	dh $@ --with ada-library
+	dh $@
 
 .PHONY: override_dh_auto_build
 override_dh_auto_build:
@@ -35,7 +37,3 @@
 
 # Ignore this target from upstream Makefile.
 .PHONY: override_dh_auto_install
-
-.PHONY: override_dh_compress
-override_dh_compress:
-	dh_compress --all $(addprefix --exclude=,.ads .adb Makefile .c .h)

## libgmpada 1.4

=== Makefile ===
#    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
#    Copyright (C) 2007-2020 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

########################
# Global configuration #
########################

LIB_NAME := gmpada

SOVERSION := 2

################################
# Build and test configuration #
################################

# For build flags:
# * settings from the environment are appended and take precedence.
# * Settings from the command line fully replace the default.

# Option for the Ada compiler
ADAFLAGS := -g -O2 -gnataEfnoqQ -gnatVa -Wall -Wextra -gnatw.eH.Y \
  -gnatyBdIoOSuxy $(ADAFLAGS)

# Options for the C and C++ preprocessors
CPPFLAGS ?=

# Options for the C compiler
CFLAGS := -g -O2 -Wall -Wextra -pedantic $(CFLAGS)

# Options for the C++ compiler
CXXFLAGS := -Wall -Wextra $(CXXFLAGS)

# Options for the linker
LDFLAGS := -Wl,--as-needed -Wl,--no-allow-shlib-undefined \
  -Wl,--no-copy-dt-needed-entries -Wl,--no-undefined $(LDFLAGS)

# Options for gnatmake
GNATMAKE_OPTIONS ?=

# We want the same compiler for C, C++ and Ada, so the default value
# from Make is not sufficient.  The following works on Debian but will
# probably require a command line override in other contexts.
CC := $(shell gnatmake --version \
  | sed -E 's/^GNATMAKE (([0-9]+)\.[0-9]+).*/gcc-\1 gcc-\2/; q' \
  | xargs which)
ifneq ($(words $(CC)),1)
 $(error Failed to set CC from gnatmake output.)
endif
CXX := $(patsubst gcc-%,g++-%,$(CC))

# Objects for the linker (FOO.o, libFOO.a, libFOO.so or -lFOO)
# The order may matter with --as-needed.
LDLIBS := -lgmp $(LDLIBS)

##############################
# Installation configuration #
##############################

prefix              := /usr
datarootdir         := $(prefix)/share
libdir              := $(prefix)/lib

# The sources files are installed into a LIB_NAME subdirectory of
SRC_DIR             := $(datarootdir)/ada/adainclude

# A LIB_NAME.gpr project convenient for library usage is installed into
GPR_DIR             := $(datarootdir)/gpr

# The content of this file ignores DESTDIR.
# The GNAT ALI files are installed into a LIB_NAME subdirectory of
ALI_DIR             := $(libdir)/ada/adalib

# The static archive is installed into
A_DIR               := $(libdir)

# The shared library is installed into
SO_DIR              := $(libdir)

# DESTDIR allows staged installs. It is prefixed to actual
# installation paths but ignored otherwise.

#########
# Rules #
#########

ada_bodies      := $(wildcard src/*.adb)
ada_specs       := src/gmp-h.ads \
  $(filter-out src/gmp-h.ads,$(wildcard src/*.ads))
ada_units       := $(ada_bodies) $(filter-out $(ada_bodies:b=s),$(ada_specs))
C_SOURCES       := $(wildcard src/*.c)
C_OBJ_DYNAMIC   := $(patsubst src/%.c,obj-dynamic/%.o,$(C_SOURCES))
C_OBJ_STATIC    := $(patsubst src/%.c,obj-static/%.o, $(C_SOURCES))

# Default target is:
.PHONY: build
build: obj/lib$(LIB_NAME).so.$(SOVERSION) \
       obj/lib$(LIB_NAME).a \
       obj/$(LIB_NAME).gpr

obj/lib$(LIB_NAME).so.$(SOVERSION): $(ada_bodies) $(ada_specs) $(C_OBJ_DYNAMIC) | obj
	gnatmake -c $(ada_units) -D obj-dynamic $(GNATMAKE_OPTIONS) \
          -cargs $(ADAFLAGS) -fPIC
	$(CC) -shared -o $@ -Wl,-soname,lib$(LIB_NAME).so.$(SOVERSION) \
	  obj-dynamic/*.o $(LDFLAGS) -lgnat $(LDLIBS)

obj/lib$(LIB_NAME).a: $(ada_bodies) $(ada_specs) $(C_OBJ_STATIC) | obj
	gnatmake -c $(ada_units) -D obj-static $(GNATMAKE_OPTIONS) \
          -cargs $(ADAFLAGS)
	ar cr $@ obj-static/*.o
	ranlib $@

$(C_OBJ_DYNAMIC): obj-dynamic/%.o: src/%.c | obj-dynamic
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@ -fPIC

$(C_OBJ_STATIC): obj-static/%.o: src/%.c | obj-static
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@

obj/$(LIB_NAME).gpr: template_for_installed_project
	sed \
          -e '/@LDLIBS@/{s||$(patsubst %,"%",$(LDLIBS))|;s/" "/", "/g}' \
	  $(foreach v,ALI_DIR LIB_NAME SO_DIR SRC_DIR,-e "s|@$(v)@|$($(v))|") \
          $< > $@

src/gmp-h.ads: gmp-h.ads.sed | obj
	echo '#include <gmp.h>' > obj/tmp.h
	cd obj && $(CXX) $(CPPFLAGS) $(CXXFLAGS) --dump-ada-spec tmp.h
	sed -f $< obj/*_gmp_h.ads > $@

obj obj-dynamic obj-static:
	mkdir $@
clean::
	rm -f src/gmp-h.ads
	rm -fr obj obj-dynamic obj-static
	find -name "*~" -delete

######################################################################
.PHONY: test
test: | demo-dynamic demo-static
	$(MAKE) install DESTDIR=demo-install

	gnatmake demo.adb -o demo-dynamic/demo -D demo-dynamic $(GNATMAKE_OPTIONS) \
	  -aIdemo-install$(SRC_DIR)/$(LIB_NAME) \
	  -aOdemo-install$(ALI_DIR)/$(LIB_NAME) \
	  -cargs $(ADAFLAGS) -gnata \
	  -largs $(LDFLAGS) demo-install$(SO_DIR)/lib$(LIB_NAME).so $(LDLIBS)
	LD_LIBRARY_PATH=demo-install$(SO_DIR) demo-dynamic/demo

	gnatmake demo.adb -o demo-static/demo -D demo-static $(GNATMAKE_OPTIONS) \
	  -aIdemo-install$(SRC_DIR)/$(LIB_NAME) \
	  -aOdemo-install$(ALI_DIR)/$(LIB_NAME) \
	  -cargs $(ADAFLAGS) -gnata \
	  -largs $(LDFLAGS) demo-install$(A_DIR)/lib$(LIB_NAME).a $(LDLIBS)
	demo-static/demo

	$(MAKE) uninstall DESTDIR=demo-install
	test `find demo-install -type f | wc -l` = 0

demo-dynamic demo-static:
	mkdir $@
clean::
	rm -f b~demo.adb b~demo.ads b~demo.ali b~demo.o
	rm -fr demo-dynamic demo-install demo-static

######################################################################
.PHONY: install
install: build
	install -m644 -Dt$(DESTDIR)$(SRC_DIR)/$(LIB_NAME) $(ada_bodies) $(ada_specs) $(C_SOURCES)
	install -m644 -Dt$(DESTDIR)$(GPR_DIR) obj/$(LIB_NAME).gpr
	install -m444 -Dt$(DESTDIR)$(ALI_DIR)/$(LIB_NAME) obj-dynamic/*.ali
	install -m644 -Dt$(DESTDIR)$(A_DIR) obj/lib$(LIB_NAME).a
	install -m644 -Dt$(DESTDIR)$(SO_DIR) obj/lib$(LIB_NAME).so.$(SOVERSION)
	ln -fs lib$(LIB_NAME).so.$(SOVERSION) $(DESTDIR)$(SO_DIR)/lib$(LIB_NAME).so

.PHONY: uninstall
uninstall:
	rm -fr $(DESTDIR)$(SRC_DIR)/$(LIB_NAME) \
	       $(DESTDIR)$(ALI_DIR)/$(LIB_NAME)
	rm -f  $(DESTDIR)$(GPR_DIR)/$(LIB_NAME).gpr \
	       $(DESTDIR)$(A_DIR)/lib$(LIB_NAME).a \
	       $(DESTDIR)$(SO_DIR)/lib$(LIB_NAME).so.$(SOVERSION) \
	       $(DESTDIR)$(SO_DIR)/lib$(LIB_NAME).so

######################################################################
.PHONY: clean

=== debian/changelog ===
libgmpada (1.4-4) unstable; urgency=medium

  * Reupload to unstable for the gnat-11 transition
  * Configure branch names for git-buildpackage
  * Require dh-ada-library 7.5, which generates ada:Depends differently

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 08 May 2022 18:22:26 +0200

libgmpada (1.4-3) experimental; urgency=medium

  * Rebuild with gnat-11. Rename -dev package accordingly.
  * Standards-Version 4.6.0.
  * Adapt to changes in debian_packaging.mk.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 13 Mar 2022 22:00:20 +0000

libgmpada (1.4-2) unstable; urgency=medium

  * Reupload to unstable for gnat-10 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 13 Dec 2020 12:09:59 +0100

libgmpada (1.4-1) experimental; urgency=medium

  * Build with gnat-10. Rename lib and -dev package accordingly.
  * New upstream release.
  * Pass build flags via the environment
  * Refresh debhelper usage.
    No need to mention README.Debian in debian/docs anymore
    Drop obsolete Pre-Depends
  * Refresh dh-ada-library usage.
    Drop explicit dependency on libgmp-dev, now in ada:Depends.
    Move -lgmp from Library_Options to Linker_Options.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 22 May 2020 00:30:12 +0000

=== debian/control ===
Source: libgmpada
Section: libdevel
Priority: optional
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-ada-library (>= 7.5),
 dh-sequence-ada-library,
 gnat,
 gnat-11,
 g++-11,
# The same version is required to generate the thin binding.
 libgmp-dev,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/libgmpada
Vcs-Git: https://salsa.debian.org/debian/libgmpada.git
Homepage: http://nicolas.boulenguez.free.fr

Package: libgmpada11-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Description: Ada binding to the GNU MultiPrecision library: development
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats.
 .
 Install this package if you want to write programs that
 use libgmpada.

Package: libgmpada8
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ada binding to the GNU MultiPrecision library: shared library
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats.
 .
 This package contains the runtime shared library.

=== debian/rules ===
#!/usr/bin/make -f

SOVERSION != \
  sed -n '/^Package: libgmpada\([0-9.]\+\)$$/{s//\1/p;q}' debian/control

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildopts.mk
include /usr/share/ada/debian_packaging.mk

%:
	dh $@

.PHONY: override_dh_auto_build
override_dh_auto_build:
	dh_auto_build -- \
	  SOVERSION=$(SOVERSION) \
	  GNATMAKE_OPTIONS='$(GNATMAKEFLAGS)'

.PHONY: override_dh_auto_test
override_dh_auto_test:
	dh_auto_test -- \
	  SOVERSION=$(SOVERSION) \
	  GNATMAKE_OPTIONS='$(GNATMAKEFLAGS)'

# Ignore this target from upstream Makefile.
.PHONY: override_dh_auto_install

## libgmpada 1.5

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
-#    Copyright (C) 2007-2020 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
+#    Copyright (C) 2007-2022 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
 #
 #    This program is free software: you can redistribute it and/or modify
 #    it under the terms of the GNU General Public License as published by
@@ -50,6 +50,10 @@
 # Options for gnatmake
 GNATMAKE_OPTIONS ?=
 
+# A -j option in GNATMAKEFLAGS will be more efficient and produce
+# readable logs. Never allow make -j to interfer.
+.NOTPARALLEL:
+
 # We want the same compiler for C, C++ and Ada, so the default value
 # from Make is not sufficient.  The following works on Debian but will
 # probably require a command line override in other contexts.

=== debian/changelog ===
libgmpada (1.5-7) unstable; urgency=medium

  * Break/Replace libgmpada*-dev since oldstable. Closes: #1034960.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 11 May 2023 00:39:45 +0200

libgmpada (1.5-6) unstable; urgency=medium

  * Mark the autopkgtest as flaky (#1026828 affects them on i386).

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 04 Jan 2023 14:11:32 +0000

libgmpada (1.5-5) unstable; urgency=medium

  * Disable post-build tests on i386. Ugly, but #1026828 (severity normal)
    should not force libgmpada out of the bookworm release.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 02 Jan 2023 16:10:45 +0000

libgmpada (1.5-4) unstable; urgency=medium

  * Downgrade the test sometimes failing after the build on i386
    (#1026828) to a non-critical message.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 31 Dec 2022 15:08:53 +0100

libgmpada (1.5-3) unstable; urgency=medium

  * Let -dev depend on libgmp-dev (previously done by dh-ada-library).

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 30 Dec 2022 18:53:13 +0000

libgmpada (1.5-2) unstable; urgency=medium

  * Reupload to unstable for the gnat-12 transition.
  * Standards-Version: 4.6.2 (no changes).
  * Explicitly install docs to -dev package.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 27 Dec 2022 02:39:16 +0100

libgmpada (1.5-1) experimental; urgency=medium

  * Build new upstream in experimental with gnat-12 and dh-ada-library 8.1.
    Rename -dev package but not shared library.
  * Standards-Version: 4.6.1

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 30 Aug 2022 10:04:13 +0000

=== debian/control ===
--- 
+++ 
@@ -4,22 +4,23 @@
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- dh-ada-library (>= 7.5),
+ dh-ada-library (>= 8.1),
  dh-sequence-ada-library,
- gnat,
- gnat-11,
- g++-11,
+ gnat-12,
+ g++-12,
 # The same version is required to generate the thin binding.
  libgmp-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/libgmpada
 Vcs-Git: https://salsa.debian.org/debian/libgmpada.git
 Homepage: http://nicolas.boulenguez.free.fr
 
-Package: libgmpada11-dev
+Package: libgmpada12-dev
+Breaks: libgmpada8-dev, libgmpada9-dev, libgmpada10-dev, libgmpada11-dev
+Replaces: libgmpada8-dev, libgmpada9-dev, libgmpada10-dev, libgmpada11-dev
 Architecture: any
-Depends: ${misc:Depends}, ${ada:Depends}
+Depends: ${misc:Depends}, ${ada:Depends}, libgmp-dev,
 Description: Ada binding to the GNU MultiPrecision library: development
  GMPAda allows programmers to use the GNU MultiPrecision library
  within the Ada language: unbounded integers, rationals and

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/packaging.mk

MAKE_OPTS := \
  SOVERSION=$(gmpada_SO_VERSION) \
  CC=gcc-$(DEB_GNAT_VERSION) \
  GNATMAKE_OPTIONS='$(GNATMAKEFLAGS)' \
  libdir=/$(DEB_LIB_DIR) \
  SRC_DIR=/$(DEB_ADA_SOURCE_DIR) \
  GPR_DIR=/$(DEB_GNAT_PROJECT_DIR) \
  ALI_DIR=/$(DEB_ADA_LIB_INFO_DIR) \
  # EOL

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(MAKE_OPTS)

override_dh_auto_test:
  # Prevent the build from failing on i386 because of #1026828.
  ifneq ($(DEB_HOST_ARCH),i386)
	dh_auto_test -- $(MAKE_OPTS)
  endif

override_dh_auto_install:
	dh_auto_install -- $(MAKE_OPTS)

execute_before_dh_installdocs:
	dh_installdocs --package=$(gmpada_DEV_PKG) README TODO

execute_before_dh_installexamples:
	dh_installexamples --package=$(gmpada_DEV_PKG) demo.adb

=== debian/tests/control ===
Tests: link-with-shared
Depends: @, gprbuild
# Fails on i386 buildds, autopkgtest runners, but not on the porterbox.
# https://bugs.debian.org/1026828
Restrictions: flaky

## libgmpada 1.6

=== Makefile ===
--- 
+++ 
@@ -20,8 +20,6 @@
 
 LIB_NAME := gmpada
 
-SOVERSION := 2
-
 ################################
 # Build and test configuration #
 ################################
@@ -57,13 +55,10 @@
 # We want the same compiler for C, C++ and Ada, so the default value
 # from Make is not sufficient.  The following works on Debian but will
 # probably require a command line override in other contexts.
-CC := $(shell gnatmake --version \
-  | sed -E 's/^GNATMAKE (([0-9]+)\.[0-9]+).*/gcc-\1 gcc-\2/; q' \
-  | xargs which)
-ifneq ($(words $(CC)),1)
- $(error Failed to set CC from gnatmake output.)
-endif
-CXX := $(patsubst gcc-%,g++-%,$(CC))
+GNATMAKE            := gnatmake
+gnat_version := $(shell $(GNATMAKE) --version | sed 's/.* \([0-9]\+\).*/\1/;q')
+CC                  := gcc-$(gnat_version)
+CXX                 := g++-$(gnat_version)
 
 # Objects for the linker (FOO.o, libFOO.a, libFOO.so or -lFOO)
 # The order may matter with --as-needed.
@@ -81,6 +76,7 @@
 SRC_DIR             := $(datarootdir)/ada/adainclude
 
 # A LIB_NAME.gpr project convenient for library usage is installed into
+gnat_project        := $(LIB_NAME).gpr
 GPR_DIR             := $(datarootdir)/gpr
 
 # The content of this file ignores DESTDIR.
@@ -88,9 +84,14 @@
 ALI_DIR             := $(libdir)/ada/adalib
 
 # The static archive is installed into
+static_library      := lib$(LIB_NAME).a
 A_DIR               := $(libdir)
 
 # The shared library is installed into
+SOVERSION           := 2
+shared_object_name  := lib$(LIB_NAME).so.$(SOVERSION)
+shared_library      := $(shared_object_name)
+development_link    := lib$(LIB_NAME).so
 SO_DIR              := $(libdir)
 
 # DESTDIR allows staged installs. It is prefixed to actual
@@ -100,39 +101,39 @@
 # Rules #
 #########
 
-ada_bodies      := $(wildcard src/*.adb)
-ada_specs       := src/gmp-h.ads \
-  $(filter-out src/gmp-h.ads,$(wildcard src/*.ads))
-ada_units       := $(ada_bodies) $(filter-out $(ada_bodies:b=s),$(ada_specs))
-C_SOURCES       := $(wildcard src/*.c)
-C_OBJ_DYNAMIC   := $(patsubst src/%.c,obj-dynamic/%.o,$(C_SOURCES))
-C_OBJ_STATIC    := $(patsubst src/%.c,obj-static/%.o, $(C_SOURCES))
+ada_units := $(wildcard src/*.adb) \
+ src/gmp.ads \
+ src/gmp-h.ads \
+ src/gnu_multiple_precision-text_io.ads \
+ src/gnu_multiple_precision-wide_text_io.ads \
+ src/gnu_multiple_precision-wide_wide_text_io.ads
 
 # Default target is:
 .PHONY: build
-build: obj/lib$(LIB_NAME).so.$(SOVERSION) \
-       obj/lib$(LIB_NAME).a \
-       obj/$(LIB_NAME).gpr
-
-obj/lib$(LIB_NAME).so.$(SOVERSION): $(ada_bodies) $(ada_specs) $(C_OBJ_DYNAMIC) | obj
-	gnatmake -c $(ada_units) -D obj-dynamic $(GNATMAKE_OPTIONS) \
+build: obj/$(shared_library) obj/$(static_library) obj/$(gnat_project)
+
+# Phony so that GNATMAKE deals with Ada dependencies, not MAKE.
+.PHONY: obj/$(shared_library)
+obj/$(shared_library): src/gmp-h.ads obj-dynamic/gmp_macros.o | obj obj-dynamic
+	$(GNATMAKE) -c $(ada_units) -D obj-dynamic $(GNATMAKE_OPTIONS) \
           -cargs $(ADAFLAGS) -fPIC
-	$(CC) -shared -o $@ -Wl,-soname,lib$(LIB_NAME).so.$(SOVERSION) \
+	$(CC) -shared -o $@ -Wl,-soname,$(shared_object_name) \
 	  obj-dynamic/*.o $(LDFLAGS) -lgnat $(LDLIBS)
 
-obj/lib$(LIB_NAME).a: $(ada_bodies) $(ada_specs) $(C_OBJ_STATIC) | obj
-	gnatmake -c $(ada_units) -D obj-static $(GNATMAKE_OPTIONS) \
+.PHONY: obj/$(static_library)
+obj/$(static_library): src/gmp-h.ads obj-static/gmp_macros.o | obj obj-static
+	$(GNATMAKE) -c $(ada_units) -D obj-static $(GNATMAKE_OPTIONS) \
           -cargs $(ADAFLAGS)
 	ar cr $@ obj-static/*.o
 	ranlib $@
 
-$(C_OBJ_DYNAMIC): obj-dynamic/%.o: src/%.c | obj-dynamic
+obj-dynamic/gmp_macros.o: src/gmp_macros.c | obj-dynamic
 	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@ -fPIC
 
-$(C_OBJ_STATIC): obj-static/%.o: src/%.c | obj-static
+obj-static/gmp_macros.o: src/gmp_macros.c | obj-static
 	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@
 
-obj/$(LIB_NAME).gpr: template_for_installed_project
+obj/$(gnat_project): template_for_installed_project | obj
 	sed \
           -e '/@LDLIBS@/{s||$(patsubst %,"%",$(LDLIBS))|;s/" "/", "/g}' \
 	  $(foreach v,ALI_DIR LIB_NAME SO_DIR SRC_DIR,-e "s|@$(v)@|$($(v))|") \
@@ -142,6 +143,8 @@
 	echo '#include <gmp.h>' > obj/tmp.h
 	cd obj && $(CXX) $(CPPFLAGS) $(CXXFLAGS) --dump-ada-spec tmp.h
 	sed -f $< obj/*_gmp_h.ads > $@
+  # Uncomment this when debugging a new version
+  #	diff -u obj/*_gmp_h.ads $@ | less
 
 obj obj-dynamic obj-static:
 	mkdir $@
@@ -155,18 +158,20 @@
 test: | demo-dynamic demo-static
 	$(MAKE) install DESTDIR=demo-install
 
-	gnatmake demo.adb -o demo-dynamic/demo -D demo-dynamic $(GNATMAKE_OPTIONS) \
+	$(GNATMAKE) demo.adb \
+	  -o demo-dynamic/demo -D demo-dynamic $(GNATMAKE_OPTIONS) \
 	  -aIdemo-install$(SRC_DIR)/$(LIB_NAME) \
 	  -aOdemo-install$(ALI_DIR)/$(LIB_NAME) \
 	  -cargs $(ADAFLAGS) -gnata \
-	  -largs $(LDFLAGS) demo-install$(SO_DIR)/lib$(LIB_NAME).so $(LDLIBS)
+	  -largs $(LDFLAGS) demo-install$(SO_DIR)/$(development_link) $(LDLIBS)
 	LD_LIBRARY_PATH=demo-install$(SO_DIR) demo-dynamic/demo
 
-	gnatmake demo.adb -o demo-static/demo -D demo-static $(GNATMAKE_OPTIONS) \
+	$(GNATMAKE) demo.adb \
+	  -o demo-static/demo -D demo-static $(GNATMAKE_OPTIONS) \
 	  -aIdemo-install$(SRC_DIR)/$(LIB_NAME) \
 	  -aOdemo-install$(ALI_DIR)/$(LIB_NAME) \
 	  -cargs $(ADAFLAGS) -gnata \
-	  -largs $(LDFLAGS) demo-install$(A_DIR)/lib$(LIB_NAME).a $(LDLIBS)
+	  -largs $(LDFLAGS) demo-install$(A_DIR)/$(static_library) $(LDLIBS)
 	demo-static/demo
 
 	$(MAKE) uninstall DESTDIR=demo-install
@@ -181,21 +186,21 @@
 ######################################################################
 .PHONY: install
 install: build
-	install -m644 -Dt$(DESTDIR)$(SRC_DIR)/$(LIB_NAME) $(ada_bodies) $(ada_specs) $(C_SOURCES)
-	install -m644 -Dt$(DESTDIR)$(GPR_DIR) obj/$(LIB_NAME).gpr
+	install -m644 -Dt$(DESTDIR)$(SRC_DIR)/$(LIB_NAME) src/*
+	install -m644 -Dt$(DESTDIR)$(GPR_DIR) obj/$(gnat_project)
 	install -m444 -Dt$(DESTDIR)$(ALI_DIR)/$(LIB_NAME) obj-dynamic/*.ali
-	install -m644 -Dt$(DESTDIR)$(A_DIR) obj/lib$(LIB_NAME).a
-	install -m644 -Dt$(DESTDIR)$(SO_DIR) obj/lib$(LIB_NAME).so.$(SOVERSION)
-	ln -fs lib$(LIB_NAME).so.$(SOVERSION) $(DESTDIR)$(SO_DIR)/lib$(LIB_NAME).so
+	install -m644 -Dt$(DESTDIR)$(A_DIR) obj/$(static_library)
+	install -m644 -Dt$(DESTDIR)$(SO_DIR) obj/$(shared_library)
+	ln -fs $(shared_library) $(DESTDIR)$(SO_DIR)/$(development_link)
 
 .PHONY: uninstall
 uninstall:
 	rm -fr $(DESTDIR)$(SRC_DIR)/$(LIB_NAME) \
 	       $(DESTDIR)$(ALI_DIR)/$(LIB_NAME)
-	rm -f  $(DESTDIR)$(GPR_DIR)/$(LIB_NAME).gpr \
-	       $(DESTDIR)$(A_DIR)/lib$(LIB_NAME).a \
-	       $(DESTDIR)$(SO_DIR)/lib$(LIB_NAME).so.$(SOVERSION) \
-	       $(DESTDIR)$(SO_DIR)/lib$(LIB_NAME).so
+	rm -f  $(DESTDIR)$(GPR_DIR)/$(gnat_project) \
+	       $(DESTDIR)$(A_DIR)/$(static_library) \
+	       $(DESTDIR)$(SO_DIR)/$(shared_library) \
+	       $(DESTDIR)$(SO_DIR)/$(development_link)
 
 ######################################################################
 .PHONY: clean

=== debian/changelog ===
libgmpada (1.6-4build1) questing; urgency=medium

  * No-change rebuild for gnat ABI, triggered by glibc 2.42.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 21 Sep 2025 07:46:22 +0200

libgmpada (1.6-4) unstable; urgency=medium

  * Reupload to unstable for the gnat-14 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 10 Mar 2025 14:18:55 +0100

libgmpada (1.6-3) experimental; urgency=medium

  * Build with gnat-14
  * Add comments to gbp.conf
  * Update Standards-Version and copyright years.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 02 Jan 2025 14:40:59 +0100

libgmpada (1.6-2) unstable; urgency=medium

  * Reupload to unstable for the gnat-13/time_t64 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 17 Mar 2024 20:36:42 +0100

libgmpada (1.6-1) experimental; urgency=medium

  * New upstream release.
  * Upload to experimental because of the following transitions.
  * Build with gnat-13.  Rename library package with new SOversion.
  * Build with dh-ada-library/9. Remove version from -dev package name.
    Provide a name containing a hash.
    Build-Depend: gnat instead of gnat-13. Break/Replace previous -devs.
  * Use explicit debian/PACKAGE.{docs,examples} files and test
    dependencies now that the -dev package is unversioned.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 26 Dec 2023 20:38:38 +0000

=== debian/tests/control ===
Tests: link-with-shared
Depends: gprbuild, libgmpada-dev
# Fails on i386 buildds, autopkgtest runners, but not on the porterbox.
# https://bugs.debian.org/1026828
Restrictions: flaky

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
  http://nicolas.boulenguez.free.fr \
  @PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
